// ## Static XCLE_Bltn Definition
// DEFINE equal
// INTERN equal


XCLE_Primitive(_CodeCall_equal) ;


static const XCLE_CodeDef _CodeData_equal = 
	{
		"equal",
		2, { ~0,~0},
		1, { 1    },
		(const XCLE_CodeOperator) _CodeCall_equal,
		"Tests if two objects are equal"
	} ;


XCLE_Primitive(_CodeCall_equal) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	unsigned long t = 0 ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	if(XCLE_ObjectType(obj1)!=XCLE_ObjectType(obj2)) obj = XCLE_AnyToObject(XCLE_IntgNew(0)) ;
	else {
		t = XCLE_ObjectEqual(obj1,obj2) ;
#ifdef DOCHECK
		if(t==-1) {
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
		}
#endif
		obj = XCLE_AnyToObject(XCLE_IntgNew(t)) ;
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


