// ## Static XCLE_Bltn Definition
// DEFINE help
// INTERN help


XCLE_Primitive(_CodeCall_help) ;


static const XCLE_CodeDef _CodeData_help = 
	{
		"help",
		1, { 4    },
		1, { 4    },
		(const XCLE_CodeOperator) _CodeCall_help,
		"Returns the description of a primitive"
	} ;


XCLE_Primitive(_CodeCall_help) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	char str[CDEF_NAME_LEN+1] ;
	extern XCLE_ParseCtx XCL_parse_ctx ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,CDEF_NAME_LEN) ;
		obj = XCLE_AnyToObject(XCLE_StrgNew(XCLE_ParseCtx_DescByName(XCL_parse_ctx,str))) ;
		if(obj==NULL) {
			XCLE_ObjectFree(obj1) ;
			SETSTATUSNUM(PARSEERR) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


