// ## Static XCLE_Bltn Definition
// DEFINE ife
// INTERN ifelse


XCLE_Primitive(_CodeCall_ifelse) ;


static const XCLE_CodeDef _CodeData_ifelse = 
	{
		"ife",
		3, { 1, 8, 8 },
		~0,{ ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0 },
		(const XCLE_CodeOperator) _CodeCall_ifelse,
		"'If then else' control structure"
	} ;


XCLE_Primitive(_CodeCall_ifelse) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	XCLE_Object obj3 = NULL ;
       	XCLE_Exception ret ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj3 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj3==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			switch(XCLE_ObjectType(obj3)) {
			case XCLE_OT_LIST:
				if(XCLE_IntgValue((XCLE_Intg)obj1)) {
					ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj2) ;
					if(ret!=XCLE_EXCEPTION_OK) {
						XCLE_ObjectFree(obj1) ;
						XCLE_ObjectFree(obj2) ;
						XCLE_ObjectFree(obj3) ;
						SETSTATUSNUM(RUNTIME) ;
						/* return ; */
					}
				}
				else {
					ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj3) ;
					if(ret!=XCLE_EXCEPTION_OK) {
						XCLE_ObjectFree(obj1) ;
						XCLE_ObjectFree(obj2) ;
						XCLE_ObjectFree(obj3) ;
						SETSTATUSNUM(RUNTIME) ;
						/* return ; */
					}
				}
				break ;
#ifdef DOCHECK
			default:
				XCLE_ObjectFree(obj1) ;
				XCLE_ObjectFree(obj2) ;
				XCLE_ObjectFree(obj3) ;
				SETSTATUSNUM(RUNTIME) ;
				/* return ; */
#endif
			}
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			XCLE_ObjectFree(obj3) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		XCLE_ObjectFree(obj3) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	XCLE_ObjectFree(obj3) ;
	STATUSOK() ;
	/* return ; */
}


