// ## Static XCLE_Bltn Definition
// DEFINE lstbrk
// INTERN lstbrk


XCLE_Primitive(_CodeCall_lstbrk) ;


static const XCLE_CodeDef _CodeData_lstbrk = 
	{	"lstbrk",
		1, { 8    },
		~0,{ 1, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0 },
		(const XCLE_CodeOperator) _CodeCall_lstbrk,
		"Breaks a list into components and size"
	} ;


XCLE_Primitive(_CodeCall_lstbrk) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	unsigned long l = 0 ;
	unsigned long i = 0 ;
	XCLE_List lst ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		lst = (XCLE_List)obj1 ;
		l = XCLE_ListLen(lst) ;
		while(i<l) {
			obj = XCLE_ListGet(lst,i) ;
			if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
			if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
			i ++ ;
		}
		obj = XCLE_AnyToObject(XCLE_IntgNew(l)) ;
		if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}


