// ## Static XCLE_Bltn Definition
// DEFINE lstsize
// INTERN lstsize


XCLE_Primitive(_CodeCall_lstsize) ;


static const XCLE_CodeDef _CodeData_lstsize = 
	{
		"lstsize",
		1, { 8    },
		1, { 1    },
		(const XCLE_CodeOperator) _CodeCall_lstsize,
		"Size of a list"
	} ;


XCLE_Primitive(_CodeCall_lstsize) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_List lst = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_LIST:
		lst = (XCLE_List)obj1 ;
		obj = XCLE_AnyToObject(XCLE_IntgNew(XCLE_ListLen(lst))) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


