// ## Static XCLE_Bltn Definition
// DEFINE pong
// INTERN stkpong


XCLE_Primitive(_CodeCall_stkpong) ;


static const XCLE_CodeDef _CodeData_stkpong = 
	{
		"pong",
		2, {  1, ~0 },
		0, { ~0     },
		(const XCLE_CodeOperator) _CodeCall_stkpong,
		"Inserts the object stack[1] on level stack[0]"
	} ;


XCLE_Primitive(_CodeCall_stkpong) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
		if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


