// ## Static XCLE_Bltn Definition
// DEFINE strprint
// INTERN strprint


XCLE_Primitive(_CodeCall_strprint) ;


static const XCLE_CodeDef _CodeData_strprint = 
	{
		"strprint",
		1, {  4    },
		0, { ~0    },
		(const XCLE_CodeOperator) _CodeCall_strprint,
		"Prints a string with \\[abfnrt] converted"
	} ;


XCLE_Primitive(_CodeCall_strprint) {
	XCLE_Object obj1 = NULL ;
	char * str = NULL ;
	unsigned long s = 0 ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		str = malloc(XCLE_StrgLen((XCLE_Strg)obj1)+1) ;
		if(str==NULL) {
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
			break ;
		}
		str[0] = 0 ;	// Just to be sure
		s = XCLE_StrgValue((XCLE_Strg)obj1,str,XCLE_StrgLen((XCLE_Strg)obj1)) ;
		str[s] = '\0' ;
		if(write(1,str,s)<s) {
			XCLE_ObjectFree(obj1) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}


