// ## Static XCLE_Bltn Definition
// DEFINE swap
// INTERN swap


XCLE_Primitive(_CodeCall_swap) ;


static const XCLE_CodeDef _CodeData_swap = 
	{
		"swap",
		2, { ~0, ~0 },
		2, { ~0, ~0 },
		(const XCLE_CodeOperator) _CodeCall_swap,
		"swaps the two first objects on stack"
	} ;


XCLE_Primitive(_CodeCall_swap) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	if(XCLE_StackPush(GETSTACK(),obj1)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj2)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


