// ## Static XCLE_Bltn Definition
// DEFINE varexe
// INTERN CallVar


XCLE_Primitive(_CodeCall_varexe) ;


static const XCLE_CodeDef _CodeData_varexe = 
	{	"varexe",
		1, { 4    },
		~0,{~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0,},
		(const XCLE_CodeOperator) _CodeCall_varexe,
		"Execute a variable's content"
	} ;

#ifndef MAX_VAR_LEN
#define MAX_VAR_LEN 1024
#endif

XCLE_Primitive(_CodeCall_varexe) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
       	XCLE_Exception ret ;
	char str[MAX_VAR_LEN+1] ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,MAX_VAR_LEN) ;
		obj2 = XCLE_HashGet(GETNAMES(),str) ;
		if(obj2==NULL) {
			SETSTATUSNUM(NOSUCHVR) ;
			/* return ; */
		}
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_LIST:
			ret = XCLE_ListEval(ctx,GETSTACK(),GETNAMES(),(XCLE_List)obj2) ;
			if(ret!=XCLE_EXCEPTION_OK) {
				XCLE_ObjectFree(obj1) ;
				SETSTATUSNUM(RUNTIME) ;
				/* return ; */
			}
			break ;
		default:
			XCLE_ObjectFree(obj1) ;
			SETSTATUSNUM(INVARGTYP) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}


