// ## Static XCLE_Bltn Definition
// DEFINE ** 
// INTERN numpow


XCLE_Primitive(_CodeCall_numpow) ;


static const XCLE_CodeDef _CodeData_numpow = 
	{	"**",
		2, { 3, 3 },
		1, { 3    },
		(const XCLE_CodeOperator) _CodeCall_numpow,
		"Numeric power"
	} ;


XCLE_Primitive(_CodeCall_numpow) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_IntgNew((long)pow((double)XCLE_IntgValue((XCLE_Intg)obj2),(double)XCLE_IntgValue((XCLE_Intg)obj1)))) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew((double)pow((double)XCLE_FltpValue((XCLE_Fltp)obj2),(double)XCLE_IntgValue((XCLE_Intg)obj1)))) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
	case XCLE_OT_FLTP:
		switch(XCLE_ObjectType(obj2)) {
		case XCLE_OT_INTG:
			obj = XCLE_AnyToObject(XCLE_FltpNew((double)pow((double)XCLE_IntgValue((XCLE_Intg)obj2),(double)XCLE_FltpValue((XCLE_Fltp)obj1)))) ;
			break ;
		case XCLE_OT_FLTP:
			obj = XCLE_AnyToObject(XCLE_FltpNew((double)pow((double)XCLE_FltpValue((XCLE_Fltp)obj2),(double)XCLE_FltpValue((XCLE_Fltp)obj1)))) ;
			break ;
#ifdef DOCHECK
		default:
			XCLE_ObjectFree(obj1) ;
			XCLE_ObjectFree(obj2) ;
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


