// ## Static XCLE_Bltn Definition
// DEFINE poke
// INTERN stkpoke


XCLE_Primitive(_CodeCall_stkpoke) ;


static const XCLE_CodeDef _CodeData_stkpoke = 
	{
		"poke",
		2, {  1, ~0 },
		0, { ~0     },
		(const XCLE_CodeOperator) _CodeCall_stkpoke,
		"Inserts the object stack[1] on level stack[0]"
	} ;


XCLE_Primitive(_CodeCall_stkpoke) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	unsigned long n ;
	unsigned long i ;
	XCLE_Object * tab ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
		if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	n = XCLE_IntgValue((XCLE_Intg)obj1) ;
	if(n<2) {
		XCLE_ObjectFree(obj1) ;
		STATUSOK() ;
		/* return ; */
	}
	n -- ;
	tab = malloc(n*sizeof(XCLE_Object)) ;
	if(tab==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	i = n ;
	while(i>0) {
		i -- ;
		tab[i] = XCLE_StackPop(GETSTACK()) ;
	}
	XCLE_StackPush(GETSTACK(),obj) ;
	while(i<n) {
		XCLE_StackPush(GETSTACK(),tab[i]) ;
		i ++ ;
	}
	free(tab) ;
	XCLE_ObjectFree(obj1) ;
	STATUSOK() ;
	/* return ; */
}


