// ## Static XCLE_Bltn Definition
// DEFINE toobj
// INTERN XCLE_toobj



XCLE_Primitive(_CodeCall_toobj) ;


static const XCLE_CodeDef _CodeData_toobj = 
	{
		"toobj",
		1, {  4    },
		1, { ~0    },
		(const XCLE_CodeOperator) _CodeCall_toobj,
		"Parse a string into objects"
	} ;


XCLE_Primitive(_CodeCall_toobj) {
	extern XCLE_ParseCtx XCL_parse_ctx ;
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	XCLE_List lst ;
	char * str = NULL ;
	unsigned long off = 0 ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		str = malloc(XCLE_StrgLen((XCLE_Strg)obj1)+1) ;
		if(str==NULL) {
			SETSTATUSNUM(RUNTIME) ;
			/* return ; */
			break ;
		}
		str[0] = 0 ;	// Just to be sure
		XCLE_StrgValue((XCLE_Strg)obj1,str,XCLE_StrgLen((XCLE_Strg)obj1)) ;
		lst = XCLE_ListParse(XCL_parse_ctx,str,&off) ;
		free(str) ;
		if(lst==NULL) {
			XCLE_ObjectFree(obj1) ;
			SETSTATUSNUM(PARSEERR) ;
			/* return ; */
		}
		obj = XCLE_AnyToObject(lst) ;
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


