// ## Static XCLE_Bltn Definition
// DEFINE tostr
// INTERN tostr


XCLE_Primitive(_CodeCall_tostr) ;


static const XCLE_CodeDef _CodeData_tostr = 
	{
		"tostr",
		1, { ~0     },
		1, {  4     },
		(const XCLE_CodeOperator) _CodeCall_tostr,
		"Makes a string from an object"
	} ;


XCLE_Primitive(_CodeCall_tostr) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	char * buffer ;
	unsigned long len ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	len = XCLE_ObjectToString(obj1,NULL,0) ;
	if(len==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	buffer = malloc(len+1) ;
	if(XCLE_ObjectToString(obj1,buffer,len+1)!=len) { free(buffer) ; SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	buffer[len] = '\0' ;
	obj = XCLE_AnyToObject(XCLE_StrgNew(buffer)) ;
	free(buffer) ;
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


