// ## Static XCLE_Bltn Definition
// DEFINE isintg
// INTERN IsIntg


XCLE_Primitive(_CodeCall_IsIntg) ;


static const XCLE_CodeDef _CodeData_IsIntg = 
	{
		"isintg",
		1, { ~0   },
		1, { 1    },
		(const XCLE_CodeOperator) _CodeCall_IsIntg,
		"Boolean type test for an integer"
	} ;


XCLE_Primitive(_CodeCall_IsIntg) {
	XCLE_Object obj = NULL ;
	XCLE_Object obj1 = NULL ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_INTG:
		obj = XCLE_AnyToObject(XCLE_IntgNew(1)) ;
		break ;
	default:
		obj = XCLE_AnyToObject(XCLE_IntgNew(0)) ;
	}
	XCLE_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	if(XCLE_StackPush(GETSTACK(),obj)==-1) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
	STATUSOK() ;
	/* return ; */
}


