// ## Static XCLE_Bltn Definition
// DEFINE varset
// INTERN varset


XCLE_Primitive(_CodeCall_varset) ;


static const XCLE_CodeDef _CodeData_varset = 
	{
		"varset",
		2, {  4, ~0 },
		0, { ~0     },
		(const XCLE_CodeOperator) _CodeCall_varset,
		"Stores a value in a variable"
	} ;


#ifndef MAX_VAR_LEN
#define MAX_VAR_LEN 1024
#endif


XCLE_Primitive(_CodeCall_varset) {
	XCLE_Object obj1 = NULL ;
	XCLE_Object obj2 = NULL ;
	char str[MAX_VAR_LEN+1] ;
	obj1 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	obj2 = XCLE_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
	switch(XCLE_ObjectType(obj1)) {
	case XCLE_OT_STRG:
		XCLE_StrgValue((XCLE_Strg)obj1,str,MAX_VAR_LEN) ;
		obj2 = XCLE_HashSet(GETNAMES(),str,obj2) ;
#ifdef DOCHECK
		if(obj2==NULL) { SETSTATUSNUM(RUNTIME) ; /* return ; */ }
#endif
		break ;
#ifdef DOCHECK
	default:
		XCLE_ObjectFree(obj1) ;
		XCLE_ObjectFree(obj2) ;
		SETSTATUSNUM(RUNTIME) ;
		/* return ; */
#endif
	}
	XCLE_ObjectFree(obj1) ;
	XCLE_ObjectFree(obj2) ;
	STATUSOK() ;
	/* return ; */
}


