
const unsigned long XCL_Registry_Vers = XCLE_MAKEVERSIONID(1,2,0) ;

const unsigned long XCL_Registry_Size = 74 ;

XCLE_CodeDef XCL_Registry_Table[74] = {
	{	"**", 2, { 3, 3 }, 1, { 3    }, (const XCLE_CodeOperator) _CodeCall_numpow, "Numeric power" }  ,
	{ "isstrg", 1, { ~0   }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_IsStrg, "Boolean type test for a string" }  ,
	{ "isfltp", 1, { ~0   }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_IsFltp, "Boolean type test for a float" }  ,
	{ "print", 1, { ~0   }, 0, { ~0   }, (const XCLE_CodeOperator) _CodeCall_print, "Prints an object" }  ,
	{ "if", 2, { 1, 8 }, ~0,{ ~0,  ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0}, (const XCLE_CodeOperator) _CodeCall_if, "'If then' control structure" }  ,
	{ "loop", 1, { 8    }, ~0, { ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0}, (const XCLE_CodeOperator) _CodeCall_loop, "Loops execution of a portion of code until false is returned" }  ,
	{ "println", 1, { ~0    }, 0, { ~0    }, (const XCLE_CodeOperator) _CodeCall_println, "Prints an object and \\n" }  ,
	{	"gt", 2, { 3, 3 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_numgt, "Numeric greater-than comparison" }  ,
	{ "dropN", 1, { 1    }, 0, {~0    }, (const XCLE_CodeOperator) _CodeCall_dropN, "Drops the N first object on stack" }  ,
	{ "dupN", 1, { 1    }, ~0,{ ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0}, (const XCLE_CodeOperator) _CodeCall_dupN, "Duplicates the N first objects on stack in order" }  ,
	{	"!=", 2, {  3, 3  }, 1, {  1     }, (const XCLE_CodeOperator) _CodeCall_numne, "Numeric unequality" }  ,
	{ "^", 2, {  1,  1 }, 1, {  1     }, (const XCLE_CodeOperator) _CodeCall_bitxor, "Bitwise XOR" }  ,
	{ "varset", 2, {  4, ~0 }, 0, { ~0     }, (const XCLE_CodeOperator) _CodeCall_varset, "Stores a value in a variable" }  ,
	{	"lstpush", 2, { ~0, 8 }, 1, { 8    }, (const XCLE_CodeOperator) _CodeCall_lstpush, "Pushes an object at the end of a list" }  ,
	{ "swap", 2, { ~0, ~0 }, 2, { ~0, ~0 }, (const XCLE_CodeOperator) _CodeCall_swap, "swaps the two first objects on stack" }  ,
	{ "|", 2, { 1, 1 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_bitor, "Bitwise OR" }  ,
	{ "undef", 0, { ~0     }, 1, {  0     }, (const XCLE_CodeOperator) _CodeCall_undef, "Pushes 'undef'" }  ,
	{	"lstcat", 2, { 8, 8 }, 1, { 8    }, (const XCLE_CodeOperator) _CodeCall_lstcat, "Concatenes two lists" }  ,
	{	"lt", 2, { 3, 3 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_numlt, "Numeric less-than comparison" }  ,
	{ "peek", 1, { 1    }, 1, { ~0   }, (const XCLE_CodeOperator) _CodeCall_stkpeek, "Gets the object on level stack[0]" }  ,
	{ "tostr", 1, { ~0     }, 1, {  4     }, (const XCLE_CodeOperator) _CodeCall_tostr, "Makes a string from an object" }  ,
	{ "lstmap", 2, {  8,  8 }, 1, {  8     }, (const XCLE_CodeOperator) _CodeCall_lstmap, "Transforms each element in a list by executing on it a code block" }  ,
	{	"++", 1, { 3    }, 1, { 3    }, (const XCLE_CodeOperator) _CodeCall_numinc, "Numeric 1-incrementation" }  ,
	{ "stkprint", 0, { ~0   }, 0, { ~0   }, (const XCLE_CodeOperator) _CodeCall_stkprint, "Prints the stack" }  ,
	{ "lstsize", 1, { 8    }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_lstsize, "Size of a list" }  ,
	{ "strlen", 1, {  4    }, 1, {  1    }, (const XCLE_CodeOperator) _CodeCall_strlen, "Returns the length of a string" }  ,
	{	"drop", 1, { ~0   }, 0, { ~0   }, (const XCLE_CodeOperator) _CodeCall_drop, "Drops the first object on stack" }  ,
	{ "true", 0, { ~0     }, 1, {  1     }, (const XCLE_CodeOperator) _CodeCall_true, "Always true" }  ,
	{	"die", 0, { ~0   }, 0, {  0   }, (const XCLE_CodeOperator) _CodeCall_die, "Dies on the spot" }  ,
	{ "error", 2, { 1, 4 }, 0, { ~0   }, (const XCLE_CodeOperator) _CodeCall_error, "Aborts with specified error" }  ,
	{ "~", 1, { 1    }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_bitnot, "Bitwise 1-complement" }  ,
	{	"islist", 1, { ~0  }, 1, { 1   }, (const XCLE_CodeOperator) _CodeCall_IsList, "Boolean type test for a list" }  ,
	{ "toobj", 1, {  4    }, 1, { ~0    }, (const XCLE_CodeOperator) _CodeCall_toobj, "Parse a string into objects" }  ,
	{	"==", 2, { 3, 3 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_numeq, "Numeric equality" }  ,
	{ "vardef", 1, { 4    }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_vardef, "Tells whether a variable is defined" }  ,
	{	"strcat", 2, { 4, 4 }, 1, { 4    }, (const XCLE_CodeOperator) _CodeCall_strcat, "Concatenes two strings" }  ,
	{	"--", 1, { 3    }, 1, { 3    }, (const XCLE_CodeOperator) _CodeCall_numdec, "Numeric 1-decrementation" }  ,
	{ "||", 2, { 1, 1 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_blnor, "Boolean disjunction" }  ,
	{ "dup", 1, { ~0   }, 2, {~0, ~0}, (const XCLE_CodeOperator) _CodeCall_dup, "Duplicates the first object on stack" }  ,
	{ "rnd", 1, {  3    }, 1, {  1    }, (const XCLE_CodeOperator) _CodeCall_numrnd, "Rounds a number" }  ,
	{	"/", 2, { 3, 3 }, 1, { 3    }, (const XCLE_CodeOperator) _CodeCall_numdiv, "Numeric division" }  ,
	{	"&", 2, { 1, 1 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_bitand, "Bitwise AND" }  ,
	{ "false", 0, { ~0   }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_false, "Always False" }  ,
	{	"clear", 0, { ~0   }, 0, { ~0   }, (const XCLE_CodeOperator) _CodeCall_stkclear, "Clears the stack" }  ,
	{ "vars", 0, { ~0     }, 1, {  8     }, (const XCLE_CodeOperator) _CodeCall_varlst, "Lists all existing variables" }  ,
	{	"-", 2, { 3, 3 }, 1, { 3    }, (const XCLE_CodeOperator) _CodeCall_numsub, "Numeric substraction" }  ,
	{	"lstbrk", 1, { 8    }, ~0,{ 1, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0 }, (const XCLE_CodeOperator) _CodeCall_lstbrk, "Breaks a list into components and size" }  ,
	{ "lsttrn", 2, {  8,  8 }, 0, {  ~0     }, (const XCLE_CodeOperator) _CodeCall_lsttrn, "Executes a block on each element in a list until it returns False" }  ,
	{ "exec", 1, { 8    }, ~0,{ ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0}, (const XCLE_CodeOperator) _CodeCall_exec, "Execution of a portion of code" }  ,
	{ "lstgrp", 1, { 1, ~0}, 1, { 8    }, (const XCLE_CodeOperator) _CodeCall_lstgrp, "Groups N objects into a list" }  ,
	{	"lte", 2, { 3, 3 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_numlte, "Numeric less-than-or-equal comparison" }  ,
	{	"\\", 2, { 1, 1 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_numquo, "Integer exact quotient" }  ,
	{ "varget", 1, {  4     }, 1, { ~0     }, (const XCLE_CodeOperator) _CodeCall_varget, "Recalls a variable's value" }  ,
	{	"depth", 0, { ~0   }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_depth, "Depth of the stack" }  ,
	{ "noop", 0, { ~0   }, 0, { ~0   }, (const XCLE_CodeOperator) _CodeCall_noop, "Does nothing" }  ,
	{	"*", 2, { 3, 3 }, 1, { 3    }, (const XCLE_CodeOperator) _CodeCall_nummul, "Numeric product" }  ,
	{ "isdef", 1, { ~0   }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_IsDef, "Tells wether first object on stack is not 'undef'" }  ,
	{ "poke", 2, {  1, ~0 }, 0, { ~0     }, (const XCLE_CodeOperator) _CodeCall_stkpoke, "Inserts the object stack[1] on level stack[0]" }  ,
	{ "stkroll", 0, { ~0    }, 0, { ~0    }, (const XCLE_CodeOperator) _CodeCall_stkroll, "Rolls down the last object on stack, if any" }  ,
	{ "stkrot", 0, { ~0    }, 0, { ~0    }, (const XCLE_CodeOperator) _CodeCall_stkrot, "Rolls up the first object on stack, if any" }  ,
	{ "ife", 3, { 1, 8, 8 }, ~0,{ ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0 }, (const XCLE_CodeOperator) _CodeCall_ifelse, "'If then else' control structure" }  ,
	{	"varexe", 1, { 4    }, ~0,{~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0, ~0,}, (const XCLE_CodeOperator) _CodeCall_varexe, "Execute a variable's content" }  ,
	{	"vardel", 1, { 4    }, 0, { ~0   }, (const XCLE_CodeOperator) _CodeCall_vardel, "Undefines a variable" }  ,
	{ "help", 1, { 4    }, 1, { 4    }, (const XCLE_CodeOperator) _CodeCall_help, "Returns the description of a primitive" }  ,
	{ "isintg", 1, { ~0   }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_IsIntg, "Boolean type test for an integer" }  ,
	{ "equal", 2, { ~0,~0}, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_equal, "Tests if two objects are equal" }  ,
	{ "lstget", 2, { 1, 8 }, 1, { ~0   }, (const XCLE_CodeOperator) _CodeCall_lstget, "Gets an object by its position in a list" }  ,
	{	"lstpop", 1, { 8    }, 2, { ~0, 8 }, (const XCLE_CodeOperator) _CodeCall_lstpop, "Pops the last element of a list" }  ,
	{	"%", 2, { 1, 1 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_nummod, "Integer remainder" }  ,
	{ "!", 1, { 1    }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_blnnot, "Boolean negation" }  ,
	{	"&&", 2, { 1, 1 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_blnand, "Boolean conjunction" }  ,
	{	"gte", 2, { 3, 3 }, 1, { 1    }, (const XCLE_CodeOperator) _CodeCall_numgte, "Numeric greater-than-or-equal comparison" }  ,
	{	"+", 2, { 3, 3 }, 1, { 3    }, (const XCLE_CodeOperator) _CodeCall_numadd, "Numeric addition" }  ,
	{ "strprint", 1, {  4    }, 0, { ~0    }, (const XCLE_CodeOperator) _CodeCall_strprint, "Prints a string with \\[abfnrt] converted" }  ,
} ;
