
const unsigned long XCL_Registry_Vers = XCLE_MAKEVERSIONID(1,2,0) ;

const unsigned long XCL_Registry_Size = 31 ;

XCLE_CodeDef XCL_Registry_Table[31] = {
	{	"log", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathlog, "Natural logarithm (base e)" }  ,
	{	"max", 2, { 3, 3 }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathmax, "Maximum of two numbers" }  ,
	{	"atanh", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathatanh, "Hyperbolic arc tangent" }  ,
	{	"cosh", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathcosh, "Hyperbolic cosinus" }  ,
	{	"log+1", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathlogp1, "Natural logarithm of 1 plus argument" }  ,
	{	"cbrt", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathcbrt, "Cubic root" }  ,
	{ "E", 0, { ~0     }, 1, {  2     }, (const XCLE_CodeOperator) _CodeCall_mathcste, "The constant E" }  ,
	{	"min", 2, { 3, 3 }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathmin, "Minimum of two numbers" }  ,
	{	"cos", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathcos, "Cosinus" }  ,
	{	"acosh", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathacosh, "Hyperbolic arc cosinus" }  ,
	{	"exp10", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathexp10, "Base 10 exponential" }  ,
	{	"acos", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathacos, "Arc cosinus" }  ,
	{ "PI", 0, { ~0     }, 1, {  2     }, (const XCLE_CodeOperator) _CodeCall_mathcstpi, "The constant PI" }  ,
	{	"atan", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathatan, "Arc tangent" }  ,
	{	"ceil", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathceil, "Rounding by upper value" }  ,
	{	"exp", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathexp, "Natural exponential (base e)" }  ,
	{	"asin", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathasin, "Arc sinus" }  ,
	{	"errf", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_matherrf, "Error function: integral 0->x: exp(-t*t) dt" }  ,
	{	"floor", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathfloor, "Rounding by lower value" }  ,
	{	"sinh", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathsinh, "Hyperbolic sinus" }  ,
	{	"asinh", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathasinh, "Hyperbolic arc sinus" }  ,
	{	"sqrt", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathsqrt, "Square root" }  ,
	{	"exp2", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathexp2, "Base 2 exponential" }  ,
	{	"sin", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathsin, "Sinus" }  ,
	{	"log10", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathlog10, "Base 10 logarithm" }  ,
	{	"inv", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathinv, "Numeric opposite" }  ,
	{	"log2", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathlog2, "Base 2 logarithm" }  ,
	{	"neg", 1, { 3    }, 1, { 3    }, (const XCLE_CodeOperator) _CodeCall_mathneg, "Numeric opposite" }  ,
	{	"gamma", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathgamma, "Gamma function: integral 0->infty: t^(x-1) e^-t dt" }  ,
	{	"tanh", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathtanh, "Hyperbolic tangent" }  ,
	{	"tan", 1, { 3    }, 1, { 2    }, (const XCLE_CodeOperator) _CodeCall_mathtan, "Tangent" }  ,
} ;
